'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = plugin;

var _generator = require('./generator');

var _generator2 = _interopRequireDefault(_generator);

var _through = require('through2');

var _through2 = _interopRequireDefault(_through);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function plugin() {
	var rules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var inputOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};


	var options = Object.assign({
		processing: false,
		optimization: false,
		postfix: false,
		skipOptimization: false
	}, inputOptions);

	var srcset = new _generator2.default(options);

	function each(file, enc, next) {
		var _this = this;

		if (file.isNull() || file.isStream()) {
			next(null, file);
			return;
		}

		Promise.all(rules.map(function (rule) {
			return match(srcset, file, rule.match, function () {
				return srcset.generate(file, rule, _this.push.bind(_this));
			});
		})).then(function (results) {

			if (results.every(function (_) {
				return _ == false;
			})) {
				next(null, file);
				return;
			}

			next();
		}).catch(next);
	}

	return _through2.default.obj(each);
}

function match(srcset, file, matchers, ifMatches) {
	return srcset.matchImage(file, matchers).then(function (matches) {
		return matches ? ifMatches() : false;
	});
}
module.exports = exports['default'];